//+------------------------------------------------------------------+
//|                                                 Jim Sloman's nxc |
//|                                                      ocn nxc.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DimGray
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width4  2

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern string _                      =  "NDX settings";
extern int    NDX.Period             =  40;
extern int    NDX.TEMA.Period        =  20;
extern int    NDX.Price              =  PRICE_CLOSE;
extern string __                     =  "NST settings";
extern int    NST.Period             =  20;
extern int    NST.TEMA.Period        =  10;
extern string ___                    =  "Dynamic zones settings";
extern int    DzLookBackBars         = 35;
extern double DzStartBuyProbability  = 0.05;
extern double DzStartSellProbability = 0.05;

//
//
//
//
//

double nxc[];
double obLine[];
double osLine[];
double zeroLine[];
double tBuffer[][7];
double alphaNdx;
double alphaNst;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,zeroLine); SetIndexLabel(0,NULL);
   SetIndexBuffer(1,obLine);   SetIndexLabel(1,NULL);
   SetIndexBuffer(2,osLine);   SetIndexLabel(2,NULL);
   SetIndexBuffer(3,nxc);

   //
   //
   //
   //
   //
   
   string PriceType;
      switch(NDX.Price)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
         case PRICE_OPEN:     PriceType = "Open";     break;  // 1
         case PRICE_HIGH:     PriceType = "High";     break;  // 2
         case PRICE_LOW:      PriceType = "Low";      break;  // 3
         case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
         case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
      }      

   //
   //
   //
   //
   //

   NDX.TEMA.Period = MathMax(NDX.TEMA.Period,1);
   NDX.Period      = MathMax(NDX.Period ,1);
   NST.TEMA.Period = MathMax(NST.TEMA.Period,1);
   NST.Period      = MathMax(NST.Period ,1);
     alphaNdx = 2.0 /(1.0 + NDX.TEMA.Period);
     alphaNst = 2.0 /(1.0 + NST.TEMA.Period);
           
   IndicatorShortName ("nxc (ndx: "+NDX.Period+","+NDX.TEMA.Period+","+PriceType+") (nst: "+NST.Period+","+NST.TEMA.Period+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iPrc 6

//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,k,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-NDX.Period-1);
         limit = MathMin(limit            ,Bars-NST.Period-1);
         if (ArrayRange(tBuffer,0) != Bars) ArrayResize(tBuffer,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      double currPrice = iMA(NULL,0,1,0,MODE_SMA,NDX.Price,i);
         if (currPrice > 0)
               tBuffer[r][iPrc] = MathLog(currPrice);
         else  tBuffer[r][iPrc] = 0.00;
      
      //
      //
      //
      //
      //

         double sumMom = 0;
         double sumDen = 0;
         double sumDif = 0;

            for (k=1; k < NDX.Period; k++)
            {
               sumDif += MathAbs(tBuffer[r-k+1][iPrc]-tBuffer[r-k][iPrc]);
               if (sumDif !=0)
                     double stoch = (tBuffer[r][iPrc]-tBuffer[r-k][iPrc])/sumDif;
               else         stoch = 0;
               double coeff = 1.0/MathSqrt(k);
          
               sumMom += coeff*stoch;
               sumDen += coeff;
            }
         
            double ndxTemp = iTema(100.0*sumMom/sumDen,alphaNdx,0,r);
               if (ndxTemp > 90) ndxTemp =  90+( ndxTemp-90)/2.0;
               if (ndxTemp <-90) ndxTemp = -90-(-ndxTemp-90)/2.0;

      //
      //
      //   
      //
      //
      
         double max    = High[i];
         double min    = Low[i];
         double sumSto = 0;
      
            for (k=0, sumDen=0; k < NST.Period; k++)
            {
               if (max < High[i+k]) max = High[i+k];
               if (min >  Low[i+k]) min =  Low[i+k];
               if (max!=min)
                     stoch = (Close[i]-min)/(max-min);
               else  stoch = 0;
               coeff = 1.0/MathSqrt(k+1.0);
          
               sumSto += coeff*stoch;
               sumDen += coeff;
            }

            double nstTemp = iTema((200.0*sumSto/sumDen)-100.0,alphaNst,3,r);
               if (nstTemp > 85) nstTemp =  85+( nstTemp-85)/2.0;
               if (nstTemp <-85) nstTemp = -85-(-nstTemp-85)/2.0;

      //
      //
      //
      //
      //
      
         double nxcTemp = ((MathAbs(ndxTemp)*nstTemp)+(MathAbs(nstTemp)*ndxTemp))/2.0;
            if (nxcTemp>0)
                  nxcTemp = MathSqrt(nxcTemp);
            else  nxcTemp = MathSqrt(MathAbs(nxcTemp))*(-1);

         nxc[i]      = nxcTemp;
         obLine[i]   = dzBuyP (nxc, DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.01);
         osLine[i]   = dzSellP(nxc, DzStartSellProbability, DzLookBackBars, Bars, i, 0.01);
         zeroLine[i] = dzSellP(nxc, 0.5,                    DzLookBackBars, Bars, i, 0.01);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iTema(double price,double alpha,int sbuf,int i)
{
   if (i < 1)
      {
         tBuffer[i][sbuf+0] = price;
         tBuffer[i][sbuf+1] = price;
         tBuffer[i][sbuf+2] = price;
      }
   else
      {
         tBuffer[i][sbuf+0] = tBuffer[i-1][sbuf+0]+alpha*(price             -tBuffer[i-1][sbuf+0]);
         tBuffer[i][sbuf+1] = tBuffer[i-1][sbuf+1]+alpha*(tBuffer[i][sbuf+0]-tBuffer[i-1][sbuf+1]);
         tBuffer[i][sbuf+2] = tBuffer[i-1][sbuf+2]+alpha*(tBuffer[i][sbuf+1]-tBuffer[i-1][sbuf+2]);
      }
   return(3.0*tBuffer[i][sbuf+0] - 3.0*tBuffer[i][sbuf+1] + tBuffer[i][sbuf+2]);
}